LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY EXMEM_REG IS
        PORT(   SIGNAL DIN_Add_result 		: IN 	STD_LOGIC_VECTOR( 7 DOWNTO 0 );
				SIGNAL DIN_ALU_result 		: IN 	STD_LOGIC_VECTOR( 7 DOWNTO 0 );
				SIGNAL DDIN_read_data_2     : IN 	STD_LOGIC_VECTOR( 7 DOWNTO 0 );
				SIGNAL DOUT_Add_result 		: OUT 	STD_LOGIC_VECTOR( 7 DOWNTO 0 );
				SIGNAL DOUT_ALU_result 		: OUT 	STD_LOGIC_VECTOR( 7 DOWNTO 0 );
				SIGNAL DDOUT_read_data_2    : OUT   STD_LOGIC_VECTOR( 7 DOWNTO 0 );
				SIGNAL DDIN_MemtoReg 		: IN 	STD_LOGIC;
				SIGNAL DDIN_RegWrite		: IN 	STD_LOGIC;
				SIGNAL DDIN_MemRead 		: IN 	STD_LOGIC;
				SIGNAL DDIN_MemWrite 		: IN 	STD_LOGIC;
				SIGNAL DDIN_Branch 			: IN 	STD_LOGIC;
				SIGNAL DDOUT_MemtoReg 		: OUT 	STD_LOGIC;
				SIGNAL DDOUT_RegWrite		: OUT 	STD_LOGIC;
				SIGNAL DDOUT_MemRead 		: OUT 	STD_LOGIC;
				SIGNAL DDOUT_MemWrite 		: OUT	STD_LOGIC;
				SIGNAL DDOUT_Branch 		: OUT 	STD_LOGIC;
				SIGNAL DIN_Zero				: IN	STD_LOGIC;
				SIGNAL DOUT_Zero			: OUT	STD_LOGIC;
				SIGNAL DDIN_write_register_address 	: IN	STD_LOGIC_VECTOR( 4 DOWNTO 0 );
				SIGNAL DDOUT_write_register_address : OUT	STD_LOGIC_VECTOR( 4 DOWNTO 0 );
                SIGNAL clock, reset         : IN    STD_LOGIC);
END EXMEM_REG;


ARCHITECTURE behavior OF EXMEM_REG IS
BEGIN
        PROCESS
                BEGIN
                        WAIT UNTIL ( clock'EVENT ) AND ( clock = '1' );
						IF reset = '1' THEN
							DOUT_Add_result		<= "00000000";
							DOUT_ALU_result 	<= "00000000";
							DDOUT_read_data_2   <= "00000000";
							DDOUT_MemtoReg 		<= '0';
							DDOUT_RegWrite		<= '0';
							DDOUT_MemRead 		<= '0';
							DDOUT_MemWrite 		<= '0';
							DDOUT_Branch 		<= '0';
							DOUT_Zero			<= '0';
							DDOUT_write_register_address <= "00000";
			
						ELSE
	                 		DOUT_Add_result		<= DIN_Add_result;
							DOUT_ALU_result 	<= DIN_ALU_result;
							DDOUT_read_data_2   <= DDIN_read_data_2;
							DDOUT_MemtoReg 		<= DDIN_MemtoReg;
							DDOUT_RegWrite		<= DDIN_RegWrite;
							DDOUT_MemRead 		<= DDIN_MemRead;
							DDOUT_MemWrite 		<= DDIN_MemWrite;
							DDOUT_Branch 		<= DDIN_Branch;
							DOUT_Zero			<= DIN_Zero;
							DDOUT_write_register_address <= DDIN_write_register_address;

						END IF;
        END PROCESS;

END behavior;

