LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY IDEX_REG IS
        PORT(   SIGNAL DDIN_Instruction          : IN    STD_LOGIC_VECTOR( 31 DOWNTO 0 );
                SIGNAL DDIN_PC_plus_4_out        : IN    STD_LOGIC_VECTOR( 7 DOWNTO 0 );
                SIGNAL DIN_read_data_1			 : IN    STD_LOGIC_VECTOR( 7 DOWNTO 0 );
				SIGNAL DIN_read_data_2           : IN    STD_LOGIC_VECTOR( 7 DOWNTO 0 );			
				SIGNAL DDOUT_Instruction         : OUT   STD_LOGIC_VECTOR( 31 DOWNTO 0 );
                SIGNAL DDOUT_PC_plus_4_out       : OUT   STD_LOGIC_VECTOR( 7 DOWNTO 0 );
                SIGNAL DOUT_read_data_1			 : OUT   STD_LOGIC_VECTOR( 7 DOWNTO 0 );
				SIGNAL DOUT_read_data_2          : OUT   STD_LOGIC_VECTOR( 7 DOWNTO 0 );
				SIGNAL DIN_ALUop 				 : IN    STD_LOGIC_VECTOR( 1 DOWNTO 0 );
				SIGNAL DIN_RegDst 			  	 : IN 	 STD_LOGIC;
				SIGNAL DIN_ALUSrc 			     : IN 	 STD_LOGIC;
				SIGNAL DIN_MemtoReg 			 : IN 	 STD_LOGIC;
				SIGNAL DIN_RegWrite			  	 : IN 	 STD_LOGIC;
				SIGNAL DIN_MemRead 			  	 : IN 	 STD_LOGIC;
				SIGNAL DIN_MemWrite 			 : IN 	 STD_LOGIC;
				SIGNAL DIN_Branch 			  	 : IN 	 STD_LOGIC;
				SIGNAL DOUT_ALUop 				 : OUT   STD_LOGIC_VECTOR( 1 DOWNTO 0 );
				SIGNAL DOUT_RegDst 				 : OUT 	 STD_LOGIC;
				SIGNAL DOUT_ALUSrc 			     : OUT 	 STD_LOGIC;
				SIGNAL DOUT_MemtoReg 			 : OUT 	 STD_LOGIC;
				SIGNAL DOUT_RegWrite			 : OUT 	 STD_LOGIC;
				SIGNAL DOUT_MemRead 			 : OUT 	 STD_LOGIC;
				SIGNAL DOUT_MemWrite 			 : OUT	 STD_LOGIC;
				SIGNAL DOUT_Branch 			  	 : OUT 	 STD_LOGIC;
				SIGNAL DIN_Sign_extend			 : IN 	 STD_LOGIC_VECTOR( 7 DOWNTO 0 );
				SIGNAL DOUT_Sign_extend			 : OUT	 STD_LOGIC_VECTOR( 7 DOWNTO 0 );
				SIGNAL DIN_write_register_address		: IN	STD_LOGIC_VECTOR( 4 DOWNTO 0 );
				SIGNAL DOUT_write_register_address		: OUT	STD_LOGIC_VECTOR( 4 DOWNTO 0 );         
				SIGNAL clock, reset              : IN    STD_LOGIC);
END IDEX_REG;


ARCHITECTURE behavior OF IDEX_REG IS
BEGIN
        PROCESS
                BEGIN
                        WAIT UNTIL ( clock'EVENT ) AND ( clock = '1' );
						IF reset = '1' THEN
							DDOUT_Instruction 	<= "00000000000000000000000000000000";
    	                    DDOUT_PC_plus_4_out <= "00000000";
							DOUT_read_data_1 	<= "00000000";
							DOUT_read_data_2 	<= "00000000";
							DOUT_ALUop 			<= "00";
							DOUT_RegDst			<= '0';
							DOUT_ALUSrc			<= '0';
							DOUT_MemtoReg		<= '0';
							DOUT_RegWrite		<= '0';
							DOUT_MemRead		<= '0';
							DOUT_MemWrite		<= '0';
							DOUT_Branch			<= '0';
							DOUT_Sign_extend	<= "00000000";
							DOUT_write_register_address <= "00000";

						ELSE
	                        DDOUT_Instruction 	<= DDIN_Instruction;
    	                    DDOUT_PC_plus_4_out <= DDIN_PC_plus_4_out;
							DOUT_read_data_1 	<= DIN_read_data_1;
							DOUT_read_data_2 	<= DIN_read_data_2;
							DOUT_ALUop 			<= DIN_ALUop;
							DOUT_RegDst			<= DIN_RegDst;
							DOUT_ALUSrc			<= DIN_ALUSrc;
							DOUT_MemtoReg		<= DIN_MemtoReg;
							DOUT_RegWrite		<= DIN_RegWrite;
							DOUT_MemRead		<= DIN_MemRead;
							DOUT_MemWrite		<= DIN_MemWrite;
							DOUT_Branch			<= DIN_Branch;
							DOUT_Sign_extend	<= DIN_Sign_extend;
							DOUT_write_register_address <= DIN_write_register_address;

						END IF;               

        END PROCESS;

END behavior;

