LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY MEMWB_REG IS
        PORT(   SIGNAL DIN_read_data		: IN 	STD_LOGIC_VECTOR( 7 DOWNTO 0 );
				SIGNAL DDIN_ALU_result		: IN 	STD_LOGIC_VECTOR( 7 DOWNTO 0 );
				SIGNAL DOUT_read_data		: OUT 	STD_LOGIC_VECTOR( 7 DOWNTO 0 );
				SIGNAL DDOUT_ALU_result		: OUT 	STD_LOGIC_VECTOR( 7 DOWNTO 0 );
				SIGNAL DDDIN_MemtoReg 		: IN 	STD_LOGIC;
				SIGNAL DDDIN_RegWrite		: IN 	STD_LOGIC;
				SIGNAL DDDOUT_MemtoReg 		: OUT   STD_LOGIC;
				SIGNAL DDDOUT_RegWrite		: OUT   STD_LOGIC;
				SIGNAL DDDIN_write_register_address		: IN	STD_LOGIC_VECTOR( 4 DOWNTO 0 );
				SIGNAL DDDOUT_write_register_address	: OUT	STD_LOGIC_VECTOR( 4 DOWNTO 0 );				 			 
                SIGNAL clock, reset         : IN 	STD_LOGIC);
END MEMWB_REG;


ARCHITECTURE behavior OF MEMWB_REG IS
BEGIN
        PROCESS
                BEGIN
                        WAIT UNTIL ( clock'EVENT ) AND ( clock = '1' );
						IF reset = '1' THEN
	                 		DOUT_read_data		<= "00000000";
							DDOUT_ALU_result	<= "00000000";
							DDDOUT_MemtoReg 	<= '0';
							DDDOUT_RegWrite		<= '0';
							DDDOUT_write_register_address <= "00000";
		
	
						ELSE
	                 		DOUT_read_data		<= DIN_read_data;
							DDOUT_ALU_result	<= DDIN_ALU_result;
							DDDOUT_MemtoReg 	<= DDDIN_MemtoReg;
							DDDOUT_RegWrite		<= DDDIN_RegWrite;
							DDDOUT_write_register_address <= DDDIN_write_register_address;
						END IF;		
        
		END PROCESS;

END behavior;

